Index: issm/trunk/externalpackages/export_fig/ImageSelection.java
===================================================================
--- issm/trunk/externalpackages/export_fig/ImageSelection.java	(revision 21341)
+++ issm/trunk/externalpackages/export_fig/ImageSelection.java	(revision 21341)
@@ -0,0 +1,38 @@
+/*
+ * Based on code snippet from
+ * http://java.sun.com/developer/technicalArticles/releases/data/
+ *
+ * Copyright © 2008, 2010 Oracle and/or its affiliates. All rights reserved. Use is subject to license terms.
+ */
+
+import java.awt.image.BufferedImage;
+import java.awt.datatransfer.*;
+
+public class ImageSelection implements Transferable {
+    
+    private static final DataFlavor flavors[] =
+    {DataFlavor.imageFlavor};
+    
+    private BufferedImage image;
+    
+    public ImageSelection(BufferedImage image) {
+        this.image = image;
+    }
+    
+    // Transferable
+    public Object getTransferData(DataFlavor flavor) throws UnsupportedFlavorException {
+        if (flavor.equals(flavors[0]) == false) {
+            throw new UnsupportedFlavorException(flavor);
+        }
+        return image;
+    }
+    
+    public DataFlavor[] getTransferDataFlavors() {
+        return flavors;
+    }
+    
+    public boolean isDataFlavorSupported(DataFlavor
+    flavor) {
+        return flavor.equals(flavors[0]);
+    }
+}
Index: issm/trunk/externalpackages/export_fig/LICENSE
===================================================================
--- issm/trunk/externalpackages/export_fig/LICENSE	(revision 19105)
+++ issm/trunk/externalpackages/export_fig/LICENSE	(revision 21341)
@@ -1,3 +1,3 @@
-Copyright (c) 2014, Oliver J. Woodford
+Copyright (c) 2014, Oliver J. Woodford, Yair M. Altman
 All rights reserved.
 
Index: issm/trunk/externalpackages/export_fig/README
===================================================================
--- issm/trunk/externalpackages/export_fig/README	(revision 21341)
+++ issm/trunk/externalpackages/export_fig/README	(revision 21341)
@@ -0,0 +1,17 @@
+Downloaded from https://www.mathworks.com/matlabcentral/fileexchange/23629-export-fig
+
+We had to patch export_fig.m to force export_fig to use the renderers painter, otherwise it is just way to slow (opengl is the default if we have patches)
+
+Line  585:
+
+
+if ~options.renderer
+    if hasTransparency || hasPatches
+        % This is *MUCH* slower, but more accurate for patches and transparent annotations (issue #39)
+        renderer = '-opengl';
+    else
+        renderer = '-painters';
+    end
+end
+
+change to painters all the time
Index: issm/trunk/externalpackages/export_fig/append_pdfs.m
===================================================================
--- issm/trunk/externalpackages/export_fig/append_pdfs.m	(revision 19105)
+++ issm/trunk/externalpackages/export_fig/append_pdfs.m	(revision 21341)
@@ -33,15 +33,38 @@
 % setting
 
+% 26/02/15: If temp dir is not writable, use the output folder for temp
+%           files when appending (Javier Paredes); sanity check of inputs
+
 function append_pdfs(varargin)
+
+if nargin < 2,  return;  end  % sanity check
+
 % Are we appending or creating a new file
 append = exist(varargin{1}, 'file') == 2;
-if append
-    output = [tempname '.pdf'];
-else
+output = [tempname '.pdf'];
+try
+    % Ensure that the temp dir is writable (Javier Paredes 26/2/15)
+    fid = fopen(output,'w');
+    fwrite(fid,1);
+    fclose(fid);
+    delete(output);
+    isTempDirOk = true;
+catch
+    % Temp dir is not writable, so use the output folder
+    [dummy,fname,fext] = fileparts(output); %#ok<ASGLU>
+    fpath = fileparts(varargin{1});
+    output = fullfile(fpath,[fname fext]);
+    isTempDirOk = false;
+end
+if ~append
     output = varargin{1};
     varargin = varargin(2:end);
 end
 % Create the command file
-cmdfile = [tempname '.txt'];
+if isTempDirOk
+    cmdfile = [tempname '.txt'];
+else
+    cmdfile = fullfile(fpath,[fname '.txt']);
+end
 fh = fopen(cmdfile, 'w');
 fprintf(fh, '-q -dNOPAUSE -dBATCH -sDEVICE=pdfwrite -dPDFSETTINGS=/prepress -sOutputFile="%s" -f', output);
Index: issm/trunk/externalpackages/export_fig/copyfig.m
===================================================================
--- issm/trunk/externalpackages/export_fig/copyfig.m	(revision 19105)
+++ issm/trunk/externalpackages/export_fig/copyfig.m	(revision 21341)
@@ -1,2 +1,3 @@
+function fh = copyfig(fh)
 %COPYFIG Create a copy of a figure, without changing the figure
 %
@@ -15,19 +16,36 @@
 % Copyright (C) Oliver Woodford 2012
 
-function fh = copyfig(fh)
-% Set the default
-if nargin == 0
-    fh = gcf;
+% 26/02/15: If temp dir is not writable, use the dest folder for temp
+%           destination files (Javier Paredes)
+% 15/04/15: Suppress warnings during copyobj (Dun Kirk comment on FEX page 2013-10-02)
+
+    % Set the default
+    if nargin == 0
+        fh = gcf;
+    end
+    % Is there a legend?
+    if isempty(findall(fh, 'Type', 'axes', 'Tag', 'legend'))
+        % Safe to copy using copyobj
+        oldWarn = warning('off'); %#ok<WNOFF>  %Suppress warnings during copyobj (Dun Kirk comment on FEX page 2013-10-02)
+        fh = copyobj(fh, 0);
+        warning(oldWarn);
+    else
+        % copyobj will change the figure, so save and then load it instead
+        tmp_nam = [tempname '.fig'];
+        try
+            % Ensure that the temp dir is writable (Javier Paredes 26/2/15)
+            fid = fopen(tmp_nam,'w');
+            fwrite(fid,1);
+            fclose(fid);
+            delete(tmp_nam);  % cleanup
+        catch
+            % Temp dir is not writable, so use the current folder
+            [dummy,fname,fext] = fileparts(tmp_nam); %#ok<ASGLU>
+            fpath = pwd;
+            tmp_nam = fullfile(fpath,[fname fext]);
+        end
+        hgsave(fh, tmp_nam);
+        fh = hgload(tmp_nam);
+        delete(tmp_nam);
+    end
 end
-% Is there a legend?
-if isempty(findall(fh, 'Type', 'axes', 'Tag', 'legend'))
-    % Safe to copy using copyobj
-    fh = copyobj(fh, 0);
-else
-    % copyobj will change the figure, so save and then load it instead
-    tmp_nam = [tempname '.fig'];
-    hgsave(fh, tmp_nam);
-    fh = hgload(tmp_nam);
-    delete(tmp_nam);
-end
-end
Index: issm/trunk/externalpackages/export_fig/crop_borders.m
===================================================================
--- issm/trunk/externalpackages/export_fig/crop_borders.m	(revision 19105)
+++ issm/trunk/externalpackages/export_fig/crop_borders.m	(revision 21341)
@@ -1,81 +1,157 @@
+function [A, vA, vB, bb_rel] = crop_borders(A, bcol, padding, crop_amounts)
 %CROP_BORDERS Crop the borders of an image or stack of images
 %
-%   [B, v] = crop_borders(A, bcol, [padding])
+%   [B, vA, vB, bb_rel] = crop_borders(A, bcol, [padding])
 %
 %IN:
 %   A - HxWxCxN stack of images.
 %   bcol - Cx1 background colour vector.
-%   padding - scalar indicating how many pixels padding to have. Default: 0.
+%   padding - scalar indicating how much padding to have in relation to
+%             the cropped-image-size (0<=padding<=1). Default: 0
+%   crop_amounts - 4-element vector of crop amounts: [top,right,bottom,left]
+%             where NaN/Inf indicate auto-cropping, 0 means no cropping,
+%             and any other value mean cropping in pixel amounts.
 %
 %OUT:
 %   B - JxKxCxN cropped stack of images.
-%   v - 1x4 vector of start and end indices for first two dimensions, s.t.
-%       B = A(v(1):v(2),v(3):v(4),:,:).
+%   vA     - coordinates in A that contain the cropped image
+%   vB     - coordinates in B where the cropped version of A is placed
+%   bb_rel - relative bounding box (used for eps-cropping)
 
-function [A, v] = crop_borders(A, bcol, padding)
-if nargin < 3
-    padding = 0;
-end
-[h, w, c, n] = size(A);
-if isscalar(bcol)
-    bcol = bcol(ones(c, 1));
-end
-bail = false;
-for l = 1:w
-    for a = 1:c
-        if ~all(col(A(:,l,a,:)) == bcol(a))
-            bail = true;
-            break;
+%{
+% 06/03/15: Improved image cropping thanks to Oscar Hartogensis
+% 08/06/15: Fixed issue #76: case of transparent figure bgcolor
+% 21/02/16: Enabled specifying non-automated crop amounts
+% 04/04/16: Fix per Luiz Carvalho for old Matlab releases
+% 23/10/16: Fixed issue #175: there used to be a 1px minimal padding in case of crop, now removed
+%}
+
+    if nargin < 3
+        padding = 0;
+    end
+    if nargin < 4
+        crop_amounts = nan(1,4);  % =auto-cropping
+    end
+    crop_amounts(end+1:4) = NaN;  % fill missing values with NaN
+
+    [h, w, c, n] = size(A);
+    if isempty(bcol)  % case of transparent bgcolor
+        bcol = A(ceil(end/2),1,:,1);
+    end
+    if isscalar(bcol)
+        bcol = bcol(ones(c, 1));
+    end
+
+    % Crop margin from left
+    if ~isfinite(crop_amounts(4))
+        bail = false;
+        for l = 1:w
+            for a = 1:c
+                if ~all(col(A(:,l,a,:)) == bcol(a))
+                    bail = true;
+                    break;
+                end
+            end
+            if bail
+                break;
+            end
         end
+    else
+        l = 1 + abs(crop_amounts(4));
     end
-    if bail
-        break;
+
+    % Crop margin from right
+    if ~isfinite(crop_amounts(2))
+        bcol = A(ceil(end/2),w,:,1);
+        bail = false;
+        for r = w:-1:l
+            for a = 1:c
+                if ~all(col(A(:,r,a,:)) == bcol(a))
+                    bail = true;
+                    break;
+                end
+            end
+            if bail
+                break;
+            end
+        end
+    else
+        r = w - abs(crop_amounts(2));
     end
-end
-bcol = A(ceil(end/2),w,:,1);
-bail = false;
-for r = w:-1:l
-    for a = 1:c
-        if ~all(col(A(:,r,a,:)) == bcol(a))
-            bail = true;
-            break;
+
+    % Crop margin from top
+    if ~isfinite(crop_amounts(1))
+        bcol = A(1,ceil(end/2),:,1);
+        bail = false;
+        for t = 1:h
+            for a = 1:c
+                if ~all(col(A(t,:,a,:)) == bcol(a))
+                    bail = true;
+                    break;
+                end
+            end
+            if bail
+                break;
+            end
         end
+    else
+        t = 1 + abs(crop_amounts(1));
     end
-    if bail
-        break;
+
+    % Crop margin from bottom
+    bcol = A(h,ceil(end/2),:,1);
+    if ~isfinite(crop_amounts(3))
+        bail = false;
+        for b = h:-1:t
+            for a = 1:c
+                if ~all(col(A(b,:,a,:)) == bcol(a))
+                    bail = true;
+                    break;
+                end
+            end
+            if bail
+                break;
+            end
+        end
+    else
+        b = h - abs(crop_amounts(3));
     end
-end
-bcol = A(1,ceil(end/2),:,1);
-bail = false;
-for t = 1:h
-    for a = 1:c
-        if ~all(col(A(t,:,a,:)) == bcol(a))
-            bail = true;
-            break;
+
+    if padding == 0  % no padding
+        % Issue #175: there used to be a 1px minimal padding in case of crop, now removed
+        %{
+        if ~isequal([t b l r], [1 h 1 w]) % Check if we're actually croppping
+            padding = 1; % Leave one boundary pixel to avoid bleeding on resize
+            bcol(:) = nan;  % make the 1px padding transparent
         end
+        %}
+    elseif abs(padding) < 1  % pad value is a relative fraction of image size
+        padding = sign(padding)*round(mean([b-t r-l])*abs(padding)); % ADJUST PADDING
+    else  % pad value is in units of 1/72" points
+        padding = round(padding);  % fix cases of non-integer pad value
     end
-    if bail
-        break;
+
+    if padding > 0  % extra padding
+        % Create an empty image, containing the background color, that has the
+        % cropped image size plus the padded border
+        B = repmat(bcol,[(b-t)+1+padding*2,(r-l)+1+padding*2,1,n]);  % Fix per Luiz Carvalho
+        % vA - coordinates in A that contain the cropped image
+        vA = [t b l r];
+        % vB - coordinates in B where the cropped version of A will be placed
+        vB = [padding+1, (b-t)+1+padding, padding+1, (r-l)+1+padding];
+        % Place the original image in the empty image
+        B(vB(1):vB(2), vB(3):vB(4), :, :) = A(vA(1):vA(2), vA(3):vA(4), :, :);
+        A = B;
+    else  % extra cropping
+        vA = [t-padding b+padding l-padding r+padding];
+        A = A(vA(1):vA(2), vA(3):vA(4), :, :);
+        vB = [NaN NaN NaN NaN];
     end
-end
-bcol = A(h,ceil(end/2),:,1);
-bail = false;
-for b = h:-1:t
-    for a = 1:c
-        if ~all(col(A(b,:,a,:)) == bcol(a))
-            bail = true;
-            break;
-        end
-    end
-    if bail
-        break;
-    end
-end
-% Crop the background, leaving one boundary pixel to avoid bleeding on resize
-v = [max(t-padding, 1) min(b+padding, h) max(l-padding, 1) min(r+padding, w)];
-A = A(v(1):v(2),v(3):v(4),:,:);
+
+    % For EPS cropping, determine the relative BoundingBox - bb_rel
+    bb_rel = [l-1 h-b-1 r+1 h-t+1]./[w h w h];
 end
 
 function A = col(A)
-A = A(:);
+    A = A(:);
 end
Index: issm/trunk/externalpackages/export_fig/eps2pdf.m
===================================================================
--- issm/trunk/externalpackages/export_fig/eps2pdf.m	(revision 19105)
+++ issm/trunk/externalpackages/export_fig/eps2pdf.m	(revision 21341)
@@ -1,2 +1,3 @@
+function eps2pdf(source, dest, crop, append, gray, quality, gs_options)
 %EPS2PDF  Convert an eps file to pdf format using ghostscript
 %
@@ -7,4 +8,5 @@
 %   eps2pdf(source, dest, crop, append, gray)
 %   eps2pdf(source, dest, crop, append, gray, quality)
+%   eps2pdf(source, dest, crop, append, gray, quality, gs_options)
 %
 % This function converts an eps file to pdf format. The output can be
@@ -17,21 +19,23 @@
 % system. Ghostscript can be downloaded from: http://www.ghostscript.com
 %
-%IN:
-%   source - filename of the source eps file to convert. The filename is
-%            assumed to already have the extension ".eps".
-%   dest - filename of the destination pdf file. The filename is assumed to
-%          already have the extension ".pdf".
-%   crop - boolean indicating whether to crop the borders off the pdf.
-%          Default: true.
-%   append - boolean indicating whether the eps should be appended to the
-%            end of the pdf as a new page (if the pdf exists already).
-%            Default: false.
-%   gray - boolean indicating whether the output pdf should be grayscale or
-%          not. Default: false.
+% Inputs:
+%   source  - filename of the source eps file to convert. The filename is
+%             assumed to already have the extension ".eps".
+%   dest    - filename of the destination pdf file. The filename is assumed
+%             to already have the extension ".pdf".
+%   crop    - boolean indicating whether to crop the borders off the pdf.
+%             Default: true.
+%   append  - boolean indicating whether the eps should be appended to the
+%             end of the pdf as a new page (if the pdf exists already).
+%             Default: false.
+%   gray    - boolean indicating whether the output pdf should be grayscale
+%             or not. Default: false.
 %   quality - scalar indicating the level of image bitmap quality to
 %             output. A larger value gives a higher quality. quality > 100
 %             gives lossless output. Default: ghostscript prepress default.
+%   gs_options - optional ghostscript options (e.g.: '-dNoOutputFonts'). If
+%                multiple options are needed, enclose in call array: {'-a','-b'}
 
-% Copyright (C) Oliver Woodford 2009-2011
+% Copyright (C) Oliver Woodford 2009-2014, Yair Altman 2015-
 
 % Suggestion of appending pdf files provided by Matt C at:
@@ -44,91 +48,142 @@
 
 % 9/12/2011 Pass font path to ghostscript.
+% 26/02/15: If temp dir is not writable, use the dest folder for temp
+%           destination files (Javier Paredes)
+% 28/02/15: Enable users to specify optional ghostscript options (issue #36)
+% 01/03/15: Upon GS error, retry without the -sFONTPATH= option (this might solve
+%           some /findfont errors according to James Rankin, FEX Comment 23/01/15)
+% 23/06/15: Added extra debug info in case of ghostscript error; code indentation
+% 04/10/15: Suggest a workaround for issue #41 (missing font path; thanks Mariia Fedotenkova)
+% 22/02/16: Bug fix from latest release of this file (workaround for issue #41)
 
-function eps2pdf(source, dest, crop, append, gray, quality)
-% Intialise the options string for ghostscript
-options = ['-q -dNOPAUSE -dBATCH -sDEVICE=pdfwrite -dPDFSETTINGS=/prepress -sOutputFile="' dest '"'];
-% Set crop option
-if nargin < 3 || crop
-    options = [options ' -dEPSCrop'];
-end
-% Set the font path
-fp = font_path();
-if ~isempty(fp)
-    options = [options ' -sFONTPATH="' fp '"'];
-end
-% Set the grayscale option
-if nargin > 4 && gray
-    options = [options ' -sColorConversionStrategy=Gray -dProcessColorModel=/DeviceGray'];
-end
-% Set the bitmap quality
-if nargin > 5 && ~isempty(quality)
-    options = [options ' -dAutoFilterColorImages=false -dAutoFilterGrayImages=false'];
-    if quality > 100
-        options = [options ' -dColorImageFilter=/FlateEncode -dGrayImageFilter=/FlateEncode -c ".setpdfwrite << /ColorImageDownsampleThreshold 10 /GrayImageDownsampleThreshold 10 >> setdistillerparams"'];
+    % Intialise the options string for ghostscript
+    options = ['-q -dNOPAUSE -dBATCH -sDEVICE=pdfwrite -dPDFSETTINGS=/prepress -sOutputFile="' dest '"'];
+    % Set crop option
+    if nargin < 3 || crop
+        options = [options ' -dEPSCrop'];
+    end
+    % Set the font path
+    fp = font_path();
+    if ~isempty(fp)
+        options = [options ' -sFONTPATH="' fp '"'];
+    end
+    % Set the grayscale option
+    if nargin > 4 && gray
+        options = [options ' -sColorConversionStrategy=Gray -dProcessColorModel=/DeviceGray'];
+    end
+    % Set the bitmap quality
+    if nargin > 5 && ~isempty(quality)
+        options = [options ' -dAutoFilterColorImages=false -dAutoFilterGrayImages=false'];
+        if quality > 100
+            options = [options ' -dColorImageFilter=/FlateEncode -dGrayImageFilter=/FlateEncode -c ".setpdfwrite << /ColorImageDownsampleThreshold 10 /GrayImageDownsampleThreshold 10 >> setdistillerparams"'];
+        else
+            options = [options ' -dColorImageFilter=/DCTEncode -dGrayImageFilter=/DCTEncode'];
+            v = 1 + (quality < 80);
+            quality = 1 - quality / 100;
+            s = sprintf('<< /QFactor %.2f /Blend 1 /HSample [%d 1 1 %d] /VSample [%d 1 1 %d] >>', quality, v, v, v, v);
+            options = sprintf('%s -c ".setpdfwrite << /ColorImageDict %s /GrayImageDict %s >> setdistillerparams"', options, s, s);
+        end
+    end
+    % Enable users to specify optional ghostscript options (issue #36)
+    if nargin > 6 && ~isempty(gs_options)
+        if iscell(gs_options)
+            gs_options = sprintf(' %s',gs_options{:});
+        elseif ~ischar(gs_options)
+            error('gs_options input argument must be a string or cell-array of strings');
+        else
+            gs_options = [' ' gs_options];
+        end
+        options = [options gs_options];
+    end
+    % Check if the output file exists
+    if nargin > 3 && append && exist(dest, 'file') == 2
+        % File exists - append current figure to the end
+        tmp_nam = tempname;
+        try
+            % Ensure that the temp dir is writable (Javier Paredes 26/2/15)
+            fid = fopen(tmp_nam,'w');
+            fwrite(fid,1);
+            fclose(fid);
+            delete(tmp_nam);
+        catch
+            % Temp dir is not writable, so use the dest folder
+            [dummy,fname,fext] = fileparts(tmp_nam); %#ok<ASGLU>
+            fpath = fileparts(dest);
+            tmp_nam = fullfile(fpath,[fname fext]);
+        end
+        % Copy the file
+        copyfile(dest, tmp_nam);
+        % Add the output file names
+        options = [options ' -f "' tmp_nam '" "' source '"'];
+        try
+            % Convert to pdf using ghostscript
+            [status, message] = ghostscript(options);
+        catch me
+            % Delete the intermediate file
+            delete(tmp_nam);
+            rethrow(me);
+        end
+        % Delete the intermediate file
+        delete(tmp_nam);
     else
-        options = [options ' -dColorImageFilter=/DCTEncode -dGrayImageFilter=/DCTEncode'];
-        v = 1 + (quality < 80);
-        quality = 1 - quality / 100;
-        s = sprintf('<< /QFactor %.2f /Blend 1 /HSample [%d 1 1 %d] /VSample [%d 1 1 %d] >>', quality, v, v, v, v);
-        options = sprintf('%s -c ".setpdfwrite << /ColorImageDict %s /GrayImageDict %s >> setdistillerparams"', options, s, s);
-    end
-end
-% Check if the output file exists
-if nargin > 3 && append && exist(dest, 'file') == 2
-    % File exists - append current figure to the end
-    tmp_nam = tempname;
-    % Copy the file
-    copyfile(dest, tmp_nam);
-    % Add the output file names
-    options = [options ' -f "' tmp_nam '" "' source '"'];
-    try
+        % File doesn't exist or should be over-written
+        % Add the output file names
+        options = [options ' -f "' source '"'];
         % Convert to pdf using ghostscript
         [status, message] = ghostscript(options);
-    catch me
-        % Delete the intermediate file
-        delete(tmp_nam);
-        rethrow(me);
     end
-    % Delete the intermediate file
-    delete(tmp_nam);
-else
-    % File doesn't exist or should be over-written
-    % Add the output file names
-    options = [options ' -f "' source '"'];
-    % Convert to pdf using ghostscript
-    [status, message] = ghostscript(options);
-end
-% Check for error
-if status
-    % Report error
-    if isempty(message)
-        error('Unable to generate pdf. Check destination directory is writable.');
-    else
-        error(message);
+    % Check for error
+    if status
+        % Retry without the -sFONTPATH= option (this might solve some GS
+        % /findfont errors according to James Rankin, FEX Comment 23/01/15)
+        orig_options = options;
+        if ~isempty(fp)
+            options = regexprep(options, ' -sFONTPATH=[^ ]+ ',' ');
+            status = ghostscript(options);
+            if ~status, return; end  % hurray! (no error)
+        end
+        % Report error
+        if isempty(message)
+            error('Unable to generate pdf. Check destination directory is writable.');
+        elseif ~isempty(strfind(message,'/typecheck in /findfont'))
+            % Suggest a workaround for issue #41 (missing font path)
+            font_name = strtrim(regexprep(message,'.*Operand stack:\s*(.*)\s*Execution.*','$1'));
+            fprintf(2, 'Ghostscript error: could not find the following font(s): %s\n', font_name);
+            fpath = fileparts(mfilename('fullpath'));
+            gs_fonts_file = fullfile(fpath, '.ignore', 'gs_font_path.txt');
+            fprintf(2, '  try to add the font''s folder to your %s file\n\n', gs_fonts_file);
+            error('export_fig error');
+        else
+            fprintf(2, '\nGhostscript error: perhaps %s is open by another application\n', dest);
+            if ~isempty(gs_options)
+                fprintf(2, '  or maybe the%s option(s) are not accepted by your GS version\n', gs_options);
+            end
+            fprintf(2, 'Ghostscript options: %s\n\n', orig_options);
+            error(message);
+        end
     end
-end
 end
 
 % Function to return (and create, where necessary) the font path
 function fp = font_path()
-fp = user_string('gs_font_path');
-if ~isempty(fp)
-    return
+    fp = user_string('gs_font_path');
+    if ~isempty(fp)
+        return
+    end
+    % Create the path
+    % Start with the default path
+    fp = getenv('GS_FONTPATH');
+    % Add on the typical directories for a given OS
+    if ispc
+        if ~isempty(fp)
+            fp = [fp ';'];
+        end
+        fp = [fp getenv('WINDIR') filesep 'Fonts'];
+    else
+        if ~isempty(fp)
+            fp = [fp ':'];
+        end
+        fp = [fp '/usr/share/fonts:/usr/local/share/fonts:/usr/share/fonts/X11:/usr/local/share/fonts/X11:/usr/share/fonts/truetype:/usr/local/share/fonts/truetype'];
+    end
+    user_string('gs_font_path', fp);
 end
-% Create the path
-% Start with the default path
-fp = getenv('GS_FONTPATH');
-% Add on the typical directories for a given OS
-if ispc
-    if ~isempty(fp)
-        fp = [fp ';'];
-    end
-    fp = [fp getenv('WINDIR') filesep 'Fonts'];
-else
-    if ~isempty(fp)
-        fp = [fp ':'];
-    end
-    fp = [fp '/usr/share/fonts:/usr/local/share/fonts:/usr/share/fonts/X11:/usr/local/share/fonts/X11:/usr/share/fonts/truetype:/usr/local/share/fonts/truetype'];
-end
-user_string('gs_font_path', fp);
-end
